# -*- coding: utf-8 -*-
from setuphelpers import *

to_uninstall_apps = [
    ### Windows 11 default apps
    # "Clipchamp.Clipchamp",
    # "Microsoft.BingNews",
    # "Microsoft.Paint",
    # "Microsoft.PowerAutomateDesktop",
    # "Microsoft.StorePurchaseApp",
    # "Microsoft.Todos",
    # "Microsoft.WindowsNotepad",
    # "Microsoft.WindowsTerminal",
    # "MicrosoftCorporationII.QuickAssist",
    # "MicrosoftTeams",
    # "MicrosoftWindows.Client.WebExperience",
    # "Microsoft.OneDriveSync",
    # "Microsoft.OutlookForWindows",
    # "Microsoft.Windows.DevHome",
    # "Microsoft.Windows.DevHomeAzureExtension",
    # "Microsoft.Windows.DevHomeGitHubExtension",
    ### Windows 10 default apps
    # "Microsoft.3DBuilder",
    # "Microsoft.Print3D",
    # "Microsoft.Microsoft3DViewer",
    # "Microsoft.MixedReality.Portal",
    # "Microsoft.YourPhone",
    # "Microsoft.WindowsFeedbackHub",
    # "Microsoft.Windows.Cortana",
    # "Microsoft.GetHelp",
    #'Microsoft.Appconnector',
    # "Microsoft.BingFinance",
    # "Microsoft.BingNews",
    # "Microsoft.BingSports",
    # "Microsoft.BingWeather",
    # "Microsoft.FreshPaint",
    # "Microsoft.MSPaint",
    # "Microsoft.Getstarted",
    # "Microsoft.MicrosoftOfficeHub",
    # "Microsoft.MicrosoftSolitaireCollection",
    # 'Microsoft.MicrosoftStickyNotes',
    # 'Microsoft.Office.OneNote',
    # "Microsoft.OneConnect",
    # "Microsoft.People",
    # "Microsoft.SkypeApp",
    # "Microsoft.Windows.Photos",
    # "Microsoft.WindowsAlarms",
    # "Microsoft.WindowsCalculator",
    # "Microsoft.WindowsCamera",
    # "Microsoft.WindowsMaps",
    # "Microsoft.WindowsPhone",
    # "Microsoft.WindowsSoundRecorder",
    # "Microsoft.WindowsStore",
    #"Microsoft.GamingApp",
    # "Microsoft.XboxApp",
    # "Microsoft.Xbox.TCUI",
    # "Microsoft.XboxGameOverlay",
    # "Microsoft.XboxGamingOverlay",
    # "Microsoft.XboxIdentityProvider",
    # "Microsoft.XboxSpeechToTextOverlay",
    #"Microsoft.ZuneMusic",
    #"Microsoft.ZuneVideo",
    # "microsoft.windowscommunicationsapps",
    #"Microsoft.MinecraftUWP",
    #"Microsoft.MixedReality.Portal",
    # "Microsoft.ScreenSketch"
    ### Threshold 2 apps
    # "Microsoft.CommsPhone",
    #'Microsoft.ConnectivityStore',
    # "Microsoft.Messaging",
    #'Microsoft.Office.Sway',
    ### Redstone apps
    #"Microsoft.BingFoodAndDrink",
    #"Microsoft.BingTravel",
    #"Microsoft.BingHealthAndFitness",
    # "Microsoft.WindowsReadingList",
    ### non-Microsoft
    #"9E2F88E3.Twitter",
    #"Flipboard.Flipboard",
    # "ShazamEntertainmentLtd.Shazam",
    # "king.com.*",
    # "ClearChannelRadioDigital.iHeartRadio",
    #"4DF9E0F8.Netflix",
    # "6Wunderkinder.Wunderlist",
    # "Drawboard.DrawboardPDF",
    # "2FE3CB00.PicsArt-PhotoStudio",
    #"D52A8D61.FarmVille2CountryEscape",
    # "TuneIn.TuneInRadio",
    #"TheNewYorkTimes.NYTCrossword",
    # "828B5831.HiddenCityMysteryofShadow",
    # "Microsoft.Advertising.Xaml",
    #"SpotifyAB.SpotifyMusic",
    # "7EE7776C.LinkedInforWindows"
    ### Apps which cannot be removed using Remove-AppxPackage
    #'Microsoft.BioEnrollment',
    # "Microsoft.MicrosoftEdge",
    # "Microsoft.MicrosoftEdge.Stable",
    # "Microsoft.MicrosoftEdgeDevToolsClient",
    # "Windows.ContactSupport",
    # "Microsoft.XboxGameCallableUI",
    # "Microsoft.SecHealthUI",
    # "Microsoft.Windows.CallingShellApp",
    # "Microsoft.Services.Store.Engagement",
    # "MicrosoftWindows.UndockedDevKit",
]

def install() :
    if not params.get("install_with_luti", False):
        error('WARNING: This package requires customization before use. Please modify the "to_uninstall_apps" list to include the applications you want to remove, after modification you can remove line 108 and 109 from setup.exe.Example: Uncomment "Microsoft.Paint" in the list below to remove Microsoft Paint.')

    print("Removing: Unwanted Microsoft Store applications...")
    installed_appx_packages = run_powershell("Get-AppxPackage -AllUsers")
    
    for app in installed_appx_packages :
        if app['Name'] in to_uninstall_apps :
            try :
                print("Removing : %s" % app['Name'])
                run_powershell("Remove-AppxPackage -AllUsers -Package %s" % app['PackageFullName'])
            except :
                print("Unable to remove : %s" % app['Name'])
    print("Done")


## To remove appx installed on current user 
# def session_setup():
#     print("Removing: Unwanted Microsoft Store applications...")
#     installed_appx_packages = run_powershell("Get-AppxPackage")
    
#     for app in installed_appx_packages :
#         if app['Name'] in to_uninstall_apps :
#             try :
#                 print("Removing : %s" % app['Name'])
#                 run_powershell("Remove-AppxPackage -Package %s" % app['PackageFullName'])
#             except :
#                 print("Unable to remove : %s" % app['Name'])